from __future__ import annotations
import random


UNKNOWN = '*'
GIVE_UP = '-'


def make_word_set(filename: str) -> list[str]:
    with open(filename) as r:
        text = r.read()
    words = list(set( word.upper() for word in text.split() if word.isalpha() and len(word) >= 3 ))
    return words

def get_users_guess() -> str:
    while True:
        guess = input()
        if len(guess) == 1:
            letter = guess[0].upper()
            return letter

WORD_SET = 'ONLY GUESSING WOULD LONG DISPLAY OPTIONAL NEED LOVE NOT ART SOLUTIONS INFORMATION SOME DETAIL YOU SMALL EXERCISE BRIEFLY MAKES JUST GUESSES THIS EASY TRUE BEGINNER PLAYER ADDS LETTER FEW ARE WORKING REPEATED TIPS WHY MUST EXERCISES HERE PYTHON LIKE INTEGERS CONCEPT CONCEPTS CHANGE COPY ELEMENT CLEANER WILL ADVANTAGE HAPPY AND MEAN FILE TELLING FASTER TAKE GUESS WROTE RATHER LOGIC NOW USE LIST STORE THAT THAN START RANDOM READ ORGANIZATION ALL TOO HOW FOR UNDERSTAND ELEMENTS RESOURCES BASICALLY NEXT SHARE PARTS ITEMS USER WHICH EACH WHEN MANY SOLUTION SUPER LET DID FOLLOWING THERE MAKE CONFUSED EMPTY VERY THEM IMPORTANT CHECK LOCKED COLLECTION SET STARTING DISTINCTION HAVE OBJECTS BLOG GOOD PICTURE USED KEEP MEANS MORE PREVIOUS WHAT CANNOT FAST STACK OVER FLOW FROM HANDLING SETS TOGETHER PICKED ANY SUBMIT BUILDING LOADED CODE COPYRIGHT TELL PENALIZE EXACTLY LETTERS HANGMAN WANT PRACTICE DOING THE LISTS FORGOT KNOW SAME LOTS THINK CHALLENGING JOURNEY ABOUT HAS YOUR WITH REASON FINISHED LEARNERS THING BRIEF ALREADY GET WINS HOME LOT ASK NUMBER SHOULD FALSE DISCUSSED PIECE CAN FINISH BEFORE LEAVE BUT DISCUSSION INCORRECT WHETHER NEW ADVERTISING GAME BECAUSE DISPLAYING LOSE DISCLOSURE TRACK HELP CALLED PART JANUARY ADD INTO MOST MUCH OTHER FUNCTIONS PUT USEFUL THEY WORD'.split()

def main() -> None:
    words = WORD_SET  # make_word_set('source_text.txt')
    secret_word = random.choice(words)
    guess = UNKNOWN * len(secret_word)
    discarded = set()
    n_lives = 10
    print("Let's play Hangman!")
    print(f"Guess what word is hidden under {UNKNOWN}. Type one letter at a time and press enter, until you find the whole word (or die). Type {GIVE_UP} when you give up.\n")

    while UNKNOWN in guess and n_lives > 0:
        life_word = 'life' if n_lives == 1 else 'lives'
        discarded_letters = ''.join(c for c in sorted(discarded) if c not in secret_word)
        discarded_message = f', discarded letters: {discarded_letters}' if len(discarded_letters) > 0 else ''
        print(f"{guess}   ({n_lives} {life_word}{discarded_message})")
        letter = get_users_guess()
        if letter == GIVE_UP:
            return
        elif letter in discarded:
            print(f"You've already tried {letter}")
        else:
            discarded.add(letter)
            if letter in secret_word:
                guess = ''.join( g if g != UNKNOWN else letter if s == letter else UNKNOWN for g, s in zip(guess, secret_word) )
                print(":)")
            else:
                n_lives -= 1
                print(":(")
        print()

    if n_lives == 0:
        print(f"Game over")
    else:
        print("Congratulations")

    print(f"It was {secret_word}\n")


if __name__ == '__main__':
    main()
